//=====
//
// This program is translated from BCB version of RinningLine by Rich Wang.
//
//#####

unit RunningLine0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    btnShow: TButton;
    Timer1: TTimer;
    btnStep: TButton;
    Image1: TImage;
    procedure btnShowClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnStepClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  Point2D = record
      x, y : integer;
  end;

var
  Form1 : TForm1;
  shift : array[0..1] of integer;
  pts : array[0..20] of Point2D
      = ( (x:0; y:1),  // show ""
          (x:0; y:0),(x:9; y:0),(x:9; y:1),(x:5; y:1),(x:5; y:3),
          (x:7; y:3),(x:7; y:4),(x:5; y:4),(x:5; y:6),(x:8; y:6),
          (x:8; y:7),(x:1; y:7),(x:1; y:6),(x:4; y:6),(x:4; y:1),
          (x:3; y:1),(x:3; y:3),(x:2; y:3),(x:2; y:1),(x:0; y:1)
        );
  times : integer;      

implementation

{$R *.dfm}
//=====
var
  stipple    : Longword	 = $FF00FF00;
  idxStipple : Longword	 = $80000000;
  lineColor  : array [0..1] of TColor = (clWhite, clRed);

procedure setStipple(pattern :Longword);
begin
  stipple := pattern;
end;

procedure assignIndex(shift :integer);
begin
  if ( shift>31 ) then
    idxStipple := $80000000
  else
    idxStipple := $80000000 shr shift;
end;

procedure runningLine(canvas :TCanvas; xstart, ystart, xend, yend :integer);
var
   i,  x, y, dx, dy, e, signx, signy, change, temp: integer;
begin
  if ( (xstart=xend) and (ystart=yend) ) then
    begin
      canvas.Pixels[xstart, ystart] := lineColor[1];
      exit;
    end;

  signx := 1;  signy:=1;
  if ( xend<xstart ) then signx:=-1;
  if ( yend<ystart ) then signy:=-1;

  dx := signx*(xend - xstart);
  dy := signy*(yend - ystart);
  if ( dy<=dx ) then
    change := 0
  else
    begin
      change:=1;
      temp:=dx; dx:=dy; dy:=temp;
    end;

  e := 2*dy - dx;
  x := xstart; y := ystart;
  for i:=0 to dx do
     begin
       if ( stipple and idxStipple <> 0 ) then   // foreground
         canvas.Pixels[x,y] := lineColor[1]      // background
       else canvas.Pixels[x,y] := lineColor[0];
       idxStipple := idxStipple shr 1;
       if ( idxStipple=0 ) then idxStipple := $80000000;

       while ( e>=0 ) do
         begin
           if ( change=0 ) then
             y := y + signy
           else x := x + signx;
           e := e - 2*dx;
         end;
       if ( change=0 ) then
         x := x + signx
       else y := y + signy;
       e := e + 2*dy;
     end;
end;

procedure runningShow(canvas :TCanvas);
var
   len, x0, y0, k : integer;
   scale : single;
begin
  x0 := 130;  y0 := 280;
  scale := 30.0;
  len := High(pts)-Low(pts)+1;
  if ( times=0 ) then
    begin
      for k:=0 to len-1 do
         begin
           pts[k].x := round(pts[k].x * scale);
           pts[k].y := round(pts[k].y * scale);
         end;
      inc(times);
    end;
  for k:=0 to len-2 do
     begin
       runningLine(canvas, x0+pts[k].x, y0-pts[k].y, x0+pts[k+1].x, y0-pts[k+1].y);
     end;
end;

//#####

procedure TForm1.btnShowClick(Sender: TObject);
begin
  Timer1.Enabled := not Timer1.Enabled;
  if ( Timer1.Enabled ) then
    btnShow.Caption := 'Stop'
  else
    btnShow.Caption := 'Start';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  assignIndex(shift[0]);
  shift[0] := (shift[0]+2) mod 32;
  runningShow(Form1.Canvas);
end;

procedure TForm1.btnStepClick(Sender: TObject);
var
   xstart, ystart, xend, yend :integer;
begin
  xstart :=  10;
  ystart :=  10;
  xend   := 400;
  yend   := 300;
  assignIndex(shift[1]);
  runningLine(Form1.Canvas, xstart, ystart, xend, yend);
  shift[1] := (shift[1]+2) mod 32;
end;

end.
